/* 
Program: matrix-product-file-v1.c (Report comments/bugs to chikh@yuntech.edu.tw)
Function: qɮŪJx}Aè̩һݺװtmOŶBxsx}eAAi歼kB
Notes: 
	1) Ji matrixData1.txtBmatrixData2.txtBmatrixData3.txt  matrixData4.txt
	2) ʺAtmG}C覡iѨĥ|椸ƲߡGuCyлPrvҸPPTɮײ64--68 
*/

#include <stdio.h>
#include <stdlib.h>

typedef struct {
	int row, col;
	int **data; /* NΩܤG}C */ 
} matrix;

int **readElements(FILE *filePtr, int row, int col)	
{
	int **data = (int**)malloc(row*sizeof(int*));
	int i, j, value;
	
	for (i = 0; i < row; i++) {
  		data[i] = (int*)malloc(col*sizeof(int));
		for (j = 0; j < col; j++) {
       		fscanf(filePtr," %d",&value); 
       		data[i][j] = value;
       }
	}
	
	return data;
}

int init(FILE *f, char *idA, matrix *A, char *idB, matrix *B)	//lAPBx}
{
    fscanf(f," %c %d %d %c %d %d",idA,&A->row,&A->col,idB,&B->row,&B->col);
    A->data = readElements(f,A->row,A->col);
    B->data = readElements(f,B->row,B->col);
    
    return 0;
}

int multiply(FILE *f, matrix *A, matrix *B, matrix *C)
{
	int i, j, k, sum;
	
	if (A->col != B->row) {
		printf("x}פ۲šALkBI");
		return -1;
		
	}
	printf("nGC_%dx%d\n",A->row,B->col);
	fprintf(f,"\n--- Output ---\nC_%dx%d\n",A->row,B->col);
	C->data = (int**)malloc(A->row*sizeof(int*));
	for (i = 0; i < A->row; i++) {
  		C->data[i] = (int*)malloc(B->col*sizeof(int));
		for (j = 0; j < B->col; j++) {
			for (k = sum = 0; k < A->col; k++)
       			sum += (A->data[i][k] * B->data[k][j]); 
       		C->data[i][j] = sum;
       		printf("%d\t",C->data[i][j]);
       		fprintf(f,"%d\t",C->data[i][j]);
       }
       printf("\n");
       fprintf(f,"\n");
	}
	C->row = A->row;
	C->col = B->col;
	
	return 0;
}

void show(char id, matrix *m)
{
	int i, j;
	
	printf("%c_%dx%d = \n",id,m->row,m->col);
	
	for (i = 0; i < m->row; i++) {
		for (j = 0; j < m->col; j++)
			printf("%d\t",m->data[i][j]);
		printf("\n");
	}
	printf("\n");
}

int main()
{   
	char 	fileName[20], idA, idB; 
    matrix 	A, B, C;
    FILE 	*f;
        
	printf("*** x}ۭB{ ***\n\nJɦW ==> ");
    scanf("%s",fileName);
        	
	if ((f = fopen(fileName,"r+")) == NULL) {
       printf("\a%sɮפsbI\n",fileName);
       return 1;
    }
    
	init(f,&idA,&A,&idB,&B);
	show(idA,&A); 
	show(idB,&B);
	freopen(fileName,"a+",f); //s}ɡANH[(append)ҦsWơAקKɮ׭즳ƳQмg 
    multiply(f,&A,&B,&C); //歼kBL{AN⵲Gܩùxsɮפ 
    fclose(f);
    
    return 0;
}
